using HeuristicLab.Common;
using System;
using System.Threading;

namespace HeuristicLab.Core.Networks {
  [Item("MyProgrammableNode", "A programmable node of a network.")]
  public class MyProgrammableNode : ProgrammableNode.CompiledProgrammableNode {
    protected MyProgrammableNode(MyProgrammableNode original, Cloner cloner) : base(original, cloner) { }
    public MyProgrammableNode(ProgrammableNode context) : base(context) { }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new MyProgrammableNode(this, cloner);
    }

    protected override void MessagePort_MessageReceived(object sender, EventArgs<IMessage, CancellationToken> e) {
      // implement processing of messages here
    }
  }
}
